' butt-ugly quickly hacked together code by saga musix
' Das Goto war halcys Idee!

#Include "fbgfx.bi"
#Include "vbcompat.bi"
#Include "bass24.bi"

Enum Directions
Dir_North = 0,
Dir_West,
Dir_South,
Dir_East,
Num_Dirs
End Enum

Type Event_Data
	As Integer posx,posy
	As Directions direction
	As String key
	As String description
	As Byte quitevent
	As String soundfx
End Type

#Define MAP_SIZE_X 6
#Define MAP_SIZE_Y 8
#Define GAME_FILE (ExePath & "/game.txt")
#Define EVENT_COUNT 50

If(Open(GAME_FILE For Input As #1)) Then
	Print "Can't locate game file!"
	End
EndIf

ScreenRes 640, 480, 32, 2, fb.GFX_FULLSCREEN Or fb.GFX_ALPHA_PRIMITIVES
SetMouse , , 0

BASS_Init(-1, 44100, 0, 0, 0)
Dim As String musicname = ExePath & "/sfx/nukedukem.mo3"
Dim As HMUSIC music = BASS_MusicLoad(0, StrPtr(musicname), 0, 0, BASS_SAMPLE_LOOP, 0)

Dim As Any Ptr gameover = ImageCreate(640, 480)
BLoad ExePath & "/img/gameover.bmp", gameover

' game_map = where can we walk on the map?
' game_images = image data
' game_events = event data
Dim As Integer game_map(0 To MAP_SIZE_X - 1, 0 To MAP_SIZE_Y - 1)
Dim As Any Ptr game_images(0 To MAP_SIZE_X - 1, 0 To MAP_SIZE_Y - 1, 0 To Num_Dirs - 1)
Dim As Event_Data game_events(0 To EVENT_COUNT)

For y As Integer = 0 To MAP_SIZE_Y - 1
	For x As Integer = 0 To MAP_SIZE_X - 1
		Input #1, game_map(x, y)
		If(game_map(x, y) <> 0) Then
			For i As Integer = 0 To Num_Dirs - 1
				Dim As String diradd = ""
				Select Case i
					Case Dir_North: diradd = "n"
					Case Dir_East: diradd = "e"
					Case Dir_West: diradd = "w"
					Case Dir_South: diradd = "s"
				End Select
				Dim As String thisFile = ExePath & "/img/" & y & "_" & x & "_" & diradd & ".bmp"
				If(FileExists(thisFile)) Then
					game_images(x, y, i) = ImageCreate(640, 480)
					BLoad thisFile, game_images(x, y, i)
				Else
					Print thisFile & " not found!"
					End
				EndIf
			Next
		EndIf
	Next
Next

Dim As Directions curdirect
Dim As Integer posx, posy
Dim As Integer startx, starty, startd
'Read start position
Input #1, startx, starty, startd


'Read events
Dim As Integer thisevent = 0
While Not EOF(1)


	Dim As String tempstr
	Line Input #1, tempstr ' placeholder
	Input #1, game_events(thisevent).posy, game_events(thisevent).posx
	Input #1, tempstr
	Select Case LCase(Trim(tempstr))
		Case "n": game_events(thisevent).direction = Dir_North
		Case "s": game_events(thisevent).direction = Dir_South
		Case "w": game_events(thisevent).direction = Dir_West
		Case "e": game_events(thisevent).direction = Dir_East
	End Select
	Input #1, game_events(thisevent).key
	If(Right(game_events(thisevent).key, 1) = "%") Then
		game_events(thisevent).key = Left(game_events(thisevent).key, Len(game_events(thisevent).key) - 1)
		game_events(thisevent).quitevent = 1
	Else
		game_events(thisevent).quitevent = 0
	EndIf
	Input #1, game_events(thisevent).soundfx
	Line Input #1, game_events(thisevent).description
	thisevent += 1
Wend

Close #1

BASS_ChannelPlay(music, 0)

GotoIsEvil: ' halcy ist schuld!
posx = startx
posy = starty
curdirect = startd

BLoad ExePath & "/img/raven-rtct.bmp"
GetKey

Dim As String keypress
Dim As Byte update = 1
Do
	keypress = Inkey
	' movement
	Select Case keypress
		Case Chr(255, 72)
			Select Case curdirect
				Case Dir_North
					If(game_map(posx, posy - 1) <> 0) Then
						posy -= 1
						update = 1
					EndIf
				Case Dir_South
					If(game_map(posx, posy + 1) <> 0) Then
						posy += 1
						update = 1
					EndIf
				Case Dir_East
					If(game_map(posx + 1, posy) <> 0) Then
						posx += 1
						update = 1
					EndIf
				Case Dir_West
					If(game_map(posx - 1, posy) <> 0) Then
						posx -= 1
						update = 1
					EndIf
			End Select
		Case Chr(255, 75)
			Select Case curdirect
				Case Dir_North: curdirect = Dir_West
				Case Dir_West: curdirect = Dir_South
				Case Dir_South: curdirect = Dir_East
				Case Dir_East: curdirect = Dir_North
			End Select
			update = 1
		Case Chr(255, 77)
			Select Case curdirect
				Case Dir_North: curdirect = Dir_East
				Case Dir_West: curdirect = Dir_North
				Case Dir_South: curdirect = Dir_West
				Case Dir_East: curdirect = Dir_South
			End Select
			update = 1
		Case Chr(255, 80)
			Select Case curdirect
				Case Dir_North
					If(game_map(posx, posy + 1) <> 0) Then
						posy += 1
						update = 1
					EndIf
				Case Dir_South
					If(game_map(posx, posy - 1) <> 0) Then
						posy -= 1
						update = 1
					EndIf
				Case Dir_East
					If(game_map(posx - 1, posy) <> 0) Then
						posx -= 1
						update = 1
					EndIf
				Case Dir_West
					If(game_map(posx + 1, posy) <> 0) Then
						posx += 1
						update = 1
					EndIf
			End Select
	End Select

	If(keypress <> "") Then
		update = 1
	EndIf

	' update screen
	If(update) Then
		ScreenLock
		Put(0,0), game_images(posx, posy, curdirect), PSet
		' Draw Map
		For y As Integer = 0 To MAP_SIZE_Y - 1
			For x As Integer = 0 To MAP_SIZE_X - 1
				Dim As UInteger thiscol = RGBA(0,0,0,128)
				If(game_map(x, y)) Then thiscol = RGBA(0,0,255,128)
				If(x = posx AndAlso y = posy) Then thiscol = RGBA(255,255,0,140)
				Line(5 + x * 10, 5 + y * 10) - (13 + x * 10, 13 + y * 10), thiscol, Bf
			Next
		Next

		' Event Text
		Line(0, 400)-(639, 479), RGBA(0,0,0,200),bf
		Dim As Byte found = 0
		For i As Integer = 0 To EVENT_COUNT
			If(game_events(i).posx = posx AndAlso game_events(i).posy = posy AndAlso game_events(i).direction = curdirect AndAlso (game_events(i).key = LCase(keypress) OrElse game_events(i).key = "_")) Then
				Dim As String tempstr = game_events(i).description
				Dim As Integer j = InStr(tempstr, "^") ' ^ = line break character
				Dim As Integer ty = 405
				While(j > 0)
					Draw String(5, ty), Left(tempstr, j - 1), RGB(255,255,255)
					tempstr = Mid(tempstr, j + 1)
					j = InStr(tempstr, "^")
					ty += 8
				Wend
				Draw String(5, ty), tempstr, RGB(255,255,255)
				found = 1

				' Play associated sound
				Dim As String soundfile = ""
				If(game_events(i).quitevent <> 0) Then soundfile = "die"
				If(game_events(i).soundfx <> "-") Then soundfile = game_events(i).soundfx
				If(soundfile <> "") Then
					soundfile = ExePath & "/sfx/" & soundfile & ".ogg"
					Dim As HSTREAM handle = BASS_StreamCreateFile(0, StrPtr(soundfile), 0, 0, BASS_STREAM_AUTOFREE)
					BASS_ChannelPlay(handle, 0)
				EndIf

				' This was a game over event
				If(game_events(i).quitevent <> 0) Then
					Put(0,0), gameover, Trans
					ScreenUnLock
					GetKey
					GoTo GotoIsEvil ' :-P
				EndIf
				Exit For
			EndIf
		Next
		If(found = 0) Then
			Draw String(5, 405), "Welcome to Castle tUM. Use the cursor keys to walk around. Find the exit!", RGB(255,255,255)
		EndIf
		update = 0
		ScreenUnLock
	EndIf

	Sleep 10

Loop Until keypress = Chr(255, 104) Or keypress = Chr(27)

BASS_Free()

